package com.hai.dao;

import com.hai.entity.OutRechargeOrder;
import com.hai.entity.OutRechargeOrderExample.Criteria;
import com.hai.entity.OutRechargeOrderExample.Criterion;
import com.hai.entity.OutRechargeOrderExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class OutRechargeOrderSqlProvider {

    public String countByExample(OutRechargeOrderExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("out_recharge_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(OutRechargeOrderExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("out_recharge_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(OutRechargeOrder record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("out_recharge_order");
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.VALUES("user_name", "#{userName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserPhone() != null) {
            sql.VALUES("user_phone", "#{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeModel() != null) {
            sql.VALUES("recharge_model", "#{rechargeModel,jdbcType=INTEGER}");
        }
        
        if (record.getPayType() != null) {
            sql.VALUES("pay_type", "#{payType,jdbcType=INTEGER}");
        }
        
        if (record.getPayPrice() != null) {
            sql.VALUES("pay_price", "#{payPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getOrderPrice() != null) {
            sql.VALUES("order_price", "#{orderPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.VALUES("pay_real_price", "#{payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.VALUES("pay_serial_no", "#{paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getRechargeContent() != null) {
            sql.VALUES("recharge_content", "#{rechargeContent,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeName() != null) {
            sql.VALUES("recharge_name", "#{rechargeName,jdbcType=VARCHAR}");
        }
        
        if (record.getIdCard() != null) {
            sql.VALUES("id_card", "#{idCard,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTimed() != null) {
            sql.VALUES("create_timed", "#{createTimed,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.VALUES("pay_time", "#{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.VALUES("cancel_time", "#{cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemarks() != null) {
            sql.VALUES("remarks", "#{remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getOutRefundNo() != null) {
            sql.VALUES("out_refund_no", "#{outRefundNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundTime() != null) {
            sql.VALUES("refund_time", "#{refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundId() != null) {
            sql.VALUES("refund_id", "#{refundId,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundFee() != null) {
            sql.VALUES("refund_fee", "#{refundFee,jdbcType=DECIMAL}");
        }
        
        if (record.getAgentKey() != null) {
            sql.VALUES("agent_key", "#{agentKey,jdbcType=VARCHAR}");
        }
        
        if (record.getObjectId() != null) {
            sql.VALUES("object_id", "#{objectId,jdbcType=INTEGER}");
        }
        
        if (record.getIdentificationCode() != null) {
            sql.VALUES("Identification_code", "#{identificationCode,jdbcType=BIGINT}");
        }
        
        return sql.toString();
    }

    public String selectByExample(OutRechargeOrderExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("order_no");
        sql.SELECT("user_id");
        sql.SELECT("user_name");
        sql.SELECT("user_phone");
        sql.SELECT("recharge_model");
        sql.SELECT("pay_type");
        sql.SELECT("pay_price");
        sql.SELECT("order_price");
        sql.SELECT("pay_real_price");
        sql.SELECT("pay_serial_no");
        sql.SELECT("`status`");
        sql.SELECT("recharge_content");
        sql.SELECT("recharge_name");
        sql.SELECT("id_card");
        sql.SELECT("create_timed");
        sql.SELECT("pay_time");
        sql.SELECT("cancel_time");
        sql.SELECT("finish_time");
        sql.SELECT("remarks");
        sql.SELECT("out_refund_no");
        sql.SELECT("refund_time");
        sql.SELECT("refund_id");
        sql.SELECT("refund_fee");
        sql.SELECT("agent_key");
        sql.SELECT("object_id");
        sql.SELECT("Identification_code");
        sql.FROM("out_recharge_order");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        OutRechargeOrder record = (OutRechargeOrder) parameter.get("record");
        OutRechargeOrderExample example = (OutRechargeOrderExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("out_recharge_order");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeModel() != null) {
            sql.SET("recharge_model = #{record.rechargeModel,jdbcType=INTEGER}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        }
        
        if (record.getPayPrice() != null) {
            sql.SET("pay_price = #{record.payPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getOrderPrice() != null) {
            sql.SET("order_price = #{record.orderPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.SET("pay_real_price = #{record.payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.SET("pay_serial_no = #{record.paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getRechargeContent() != null) {
            sql.SET("recharge_content = #{record.rechargeContent,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeName() != null) {
            sql.SET("recharge_name = #{record.rechargeName,jdbcType=VARCHAR}");
        }
        
        if (record.getIdCard() != null) {
            sql.SET("id_card = #{record.idCard,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTimed() != null) {
            sql.SET("create_timed = #{record.createTimed,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.SET("cancel_time = #{record.cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemarks() != null) {
            sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getOutRefundNo() != null) {
            sql.SET("out_refund_no = #{record.outRefundNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundTime() != null) {
            sql.SET("refund_time = #{record.refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundId() != null) {
            sql.SET("refund_id = #{record.refundId,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundFee() != null) {
            sql.SET("refund_fee = #{record.refundFee,jdbcType=DECIMAL}");
        }
        
        if (record.getAgentKey() != null) {
            sql.SET("agent_key = #{record.agentKey,jdbcType=VARCHAR}");
        }
        
        if (record.getObjectId() != null) {
            sql.SET("object_id = #{record.objectId,jdbcType=INTEGER}");
        }
        
        if (record.getIdentificationCode() != null) {
            sql.SET("Identification_code = #{record.identificationCode,jdbcType=BIGINT}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("out_recharge_order");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        sql.SET("recharge_model = #{record.rechargeModel,jdbcType=INTEGER}");
        sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        sql.SET("pay_price = #{record.payPrice,jdbcType=DECIMAL}");
        sql.SET("order_price = #{record.orderPrice,jdbcType=DECIMAL}");
        sql.SET("pay_real_price = #{record.payRealPrice,jdbcType=DECIMAL}");
        sql.SET("pay_serial_no = #{record.paySerialNo,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("recharge_content = #{record.rechargeContent,jdbcType=VARCHAR}");
        sql.SET("recharge_name = #{record.rechargeName,jdbcType=VARCHAR}");
        sql.SET("id_card = #{record.idCard,jdbcType=VARCHAR}");
        sql.SET("create_timed = #{record.createTimed,jdbcType=TIMESTAMP}");
        sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        sql.SET("cancel_time = #{record.cancelTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        sql.SET("out_refund_no = #{record.outRefundNo,jdbcType=VARCHAR}");
        sql.SET("refund_time = #{record.refundTime,jdbcType=TIMESTAMP}");
        sql.SET("refund_id = #{record.refundId,jdbcType=VARCHAR}");
        sql.SET("refund_fee = #{record.refundFee,jdbcType=DECIMAL}");
        sql.SET("agent_key = #{record.agentKey,jdbcType=VARCHAR}");
        sql.SET("object_id = #{record.objectId,jdbcType=INTEGER}");
        sql.SET("Identification_code = #{record.identificationCode,jdbcType=BIGINT}");
        
        OutRechargeOrderExample example = (OutRechargeOrderExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(OutRechargeOrder record) {
        SQL sql = new SQL();
        sql.UPDATE("out_recharge_order");
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.SET("user_name = #{userName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeModel() != null) {
            sql.SET("recharge_model = #{rechargeModel,jdbcType=INTEGER}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{payType,jdbcType=INTEGER}");
        }
        
        if (record.getPayPrice() != null) {
            sql.SET("pay_price = #{payPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getOrderPrice() != null) {
            sql.SET("order_price = #{orderPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.SET("pay_real_price = #{payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.SET("pay_serial_no = #{paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getRechargeContent() != null) {
            sql.SET("recharge_content = #{rechargeContent,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeName() != null) {
            sql.SET("recharge_name = #{rechargeName,jdbcType=VARCHAR}");
        }
        
        if (record.getIdCard() != null) {
            sql.SET("id_card = #{idCard,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTimed() != null) {
            sql.SET("create_timed = #{createTimed,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.SET("cancel_time = #{cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemarks() != null) {
            sql.SET("remarks = #{remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getOutRefundNo() != null) {
            sql.SET("out_refund_no = #{outRefundNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundTime() != null) {
            sql.SET("refund_time = #{refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundId() != null) {
            sql.SET("refund_id = #{refundId,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundFee() != null) {
            sql.SET("refund_fee = #{refundFee,jdbcType=DECIMAL}");
        }
        
        if (record.getAgentKey() != null) {
            sql.SET("agent_key = #{agentKey,jdbcType=VARCHAR}");
        }
        
        if (record.getObjectId() != null) {
            sql.SET("object_id = #{objectId,jdbcType=INTEGER}");
        }
        
        if (record.getIdentificationCode() != null) {
            sql.SET("Identification_code = #{identificationCode,jdbcType=BIGINT}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, OutRechargeOrderExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}